<?php 

Yii::app()->getClientScript()->registerCoreScript('jquery');

echo CHtml::tag( "h2", array(), $title );

echo CHtml::openTag( "div", array( 'class'=>'yiiForm' ) );
echo CHtml::beginForm( );


$entries = $feeds->getEntry();
if ( count($entries)==0 ){
    $newentry = new FeedsEntry;
    $newentry->name=Yii::t('app',"Title");
    $newentry->element="title";
    $newentry->type="text";
    $entries[] = $newentry; 
    $newentry = new FeedsEntry;
    $newentry->name=Yii::t('app',"Description");
    $newentry->element="description";
    $newentry->type="ltext";
    $entries[] = $newentry; 
    $newentry = new FeedsEntry;
    $newentry->name=Yii::t('app',"Media");
    $newentry->element="enclosure";
    $newentry->type="animation";
    $entries[] = $newentry; 
}
echo CHtml::openTag("table");
echo CHtml::openTag( "tr" );
echo CHtml::Tag( "td", array(),  CHtml::activeLabel( $entries[0], "element" ) );
echo CHtml::Tag( "td", array(),  CHtml::activeLabel( $entries[0], "name" ) );
echo CHtml::Tag( "td", array(),  CHtml::activeLabel( $entries[0], "type" ) );
echo CHtml::Tag( "td" );
echo CHtml::closeTag( "tr" );

foreach ($entries as $i => $entry ) {
    echo CHtml::errorSummary($entry);
    echo CHtml::openTag( "tr", array( 'id'=>'entry_'.$i, 'class'=>'entry' ) );
    
    echo CHtml::Tag( "td", array(), CHtml::activeTextField( $entry, "[$i]element" ) );
    echo CHtml::Tag( "td",array(),  CHtml::activeTextField( $entry, "[$i]name" ) );
    
    echo CHtml::openTag( "td" );
    echo CHtml::activeDropDownList( $entry, "[$i]type", array(  'text'=>Yii::t('app','Text'), 
                                                                'ltext'=>Yii::t('app','Long text'), 
                                                                'image'=>Yii::t('app','Image'), 
                                                                'video'=>Yii::t('app','Video'), 
                                                                'audio'=>Yii::t('app','Audio'), 
                                                                'animation'=>Yii::t('app','All media') 
                                                            ) 
                                );
    echo CHtml::closeTag( "td" );
    
    echo CHtml::Tag( "td", array(), CHtml::button(Yii::t('app','Remove'), array('name'=>'remove', 'class'=>'removeEntry')) );
    
    echo CHtml::closeTag( "tr" );
}
echo CHtml::closeTag("table");
echo CHtml::openTag( "div", array( 'class'=>'action' ) );
echo CHtml::button(Yii::t('app','More entry'), array('name'=>'addEntry', 'id'=>'addEntry'));

echo CHtml::submitButton(Yii::t('app','OK'), array("submit"=>"", "params"=>array("action"=>"Save")))." ";  
echo CHtml::submitButton(Yii::t('app','Cancel'), array("submit"=>"", "params"=>array("action"=>"Cancel")))." ";  

echo CHtml::closeTag( "div" );

echo CHtml::endForm();
echo CHtml::closeTag( "div" );

?>

<script type="text/javascript">
    /*<![CDATA[*/
   var nbEntry = <?php echo $i+1; ?>;
    // Add the event to button
    $('#addEntry').click(function () {
      // Clone the first div
      var divCloned = $('#entry_0').clone();
      // attach the clone to the end
      $('#entry_'+(nbEntry-1)).after(divCloned);
      
      // reset all the class
      divCloned.children(':text').each( function(index) { this.value = ""; this.setAttribute('class', ''); } );
      
      fixIds( );

    });
    
    function fixIds() {
        nbEntry = 0;
        $('.entry').each( function(index) {
            this.id = this.id.replace(/\d+/, index);
            $(this).children().children('input').each( function(idx2) {
                this.id = this.id.replace(/\d+/, index);
                this.name = this.name.replace(/\d+/, index);
            });
            $(this).children().children('select').each( function(idx2) {
                this.id = this.id.replace(/\d+/, index);
                this.name = this.name.replace(/\d+/, index);
            });            
            nbEntry++;            
        });

        $('.removeEntry').click(function () {
            if ( nbEntry!=1 ) 
                $(this).parent().parent().remove();
            fixIds( );
        });
    }
    
    fixIds();
   /*]]>*/
</script>